/* Copyright by Marta Kasprzak 1996 */

#define _INCLUDE_POSIX_SOURCE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/times.h>

enum Boolean { False, True};

const char litery[4] = {'A','C','G','T'};

unsigned n,l,k;
FILE *plik;

unsigned *Stos,          /* aktualna sciezka w grafie */
	 *poczatek;      /* znana poczatkowa sekwencja znakow */
			 /* (moze byc lancuchem pustym) */
unsigned defekt,         /* licznosc zbioru ubytki */
	 count,          /* licznosc zbioru spektrum */
	 pocz_len;       /* rozmiar tablicy poczatek */
double poz_zagl,il_zagl, /* zmienne potrzebne do */
			 /* obliczenia sredniego poziomu odciecia */
       ilosc_rozw;       /* ilosc wygenerowanych lancuchow */
char **ubytki,           /* aktualnie wykryte ubytki */
     **spektrum;         /* jeszcze nie uzyte podlancuchy */
enum Boolean
	wszystkie_rozw,  /* czy wypisac rozwiazania do pliku */
	liczba_rozw,     /* czy wypisac liczbe wszystkich rozwiazan */
	wsz_ubytki,      /* czy wypisac defekt dla kazdego rozwiazania */
	sr_zaglebienie;  /* czy obliczac srednie zaglebienie */

void Zainicjowanie()
{
   unsigned i,j;
   char *lancuch;

   defekt = 0;
   ilosc_rozw = 0;
   poz_zagl = il_zagl = 0;
   lancuch = (char*) malloc(80 * sizeof(char));
   plik = fopen("pliczek.kon","rt");  /* wczytanie opcji z pliku */
   fgets(lancuch,80,plik);
   n = atoi(lancuch);                 /* dlugosc docelowego lancucha */
   fgets(lancuch,80,plik);
   l = atoi(lancuch);                 /* dlugosc podlancucha */
   fgets(lancuch,80,plik);
   wszystkie_rozw = atoi(lancuch);
   fgets(lancuch,80,plik);
   liczba_rozw = atoi(lancuch);
   fgets(lancuch,80,plik);
   wsz_ubytki = atoi(lancuch);
   fgets(lancuch,80,plik);
   sr_zaglebienie = atoi(lancuch);
   fgets(lancuch,80,plik);
   fclose(plik);
   pocz_len = strcspn(lancuch," ");
   poczatek = (unsigned*) malloc(pocz_len * sizeof(unsigned));
   for (i=0; i<pocz_len; i++)
      for (j=0; j<4; j++)
	 if (litery[j] == *(lancuch+i))
	 {
	    poczatek[i] = j;
	    break;
	 }
   free(lancuch);
   Stos = (unsigned*) malloc(n * sizeof(unsigned));
   count = 0;	                      /* ilosc elementow w spektrum */
   spektrum = (char**) malloc((n-l+1) * sizeof(char*));
   for (i=0; i<n-l+1; i++)
      spektrum[i] = (char*) malloc((l+1) * sizeof(char));
   lancuch = (char*) malloc((l+3) * sizeof(char));
   plik = fopen("spektrum","rt");     /* wczytanie spektrum z pliku */
   while (fgets(lancuch,l+2,plik))
   {
      strncpy(spektrum[count],lancuch,l);
      spektrum[count++][l] = '\0';
   }
   fclose(plik);
   k = n-l+1 - count;                 /* ustalenie defektu w zbiorze */
   ubytki = (char**) malloc((k+1) * sizeof(char*));
   for (i=0; i<k+1; i++)
      ubytki[i] = (char*) malloc((l+1) * sizeof(char));
   free(lancuch);
}

/* zwalnia przydzielona pamiec */
void Koniec()
{
   unsigned i;

   for (i=0; i<n-l+1; i++)
      free(spektrum[i]);
   free(spektrum);
   for (i=0; i<k+1; i++)
      free(ubytki[i]);
   free(ubytki);
   free(Stos);
}

/* wypisuje rozwiazania do pliku */
void Write()
{
   unsigned i;

   if (wszystkie_rozw)
   {
      for (i=0; i<n; i++)
	 fputc(litery[Stos[i]],plik);
      fputc('\n',plik);
      fflush(plik);
   }
   putchar('*');
   fflush(stdout);
   ++ilosc_rozw;
}

/* zwraca ostatnia l-tke dodana do Stosu */
char *Ostatnie_l(char wyraz[],unsigned zagl)
{
   unsigned i;

   for (i=0; i<l; i++)
      wyraz[l-i-1] = litery[Stos[zagl-1-i]];
   wyraz[l] = '\0';
   return wyraz;
}

/* czy podany wyraz nalezy do zbioru sp o licznosci licz */
enum Boolean Nalezy(char *wyraz,char *sp[],unsigned licz)
{
   unsigned i = 0;

   enum Boolean nalezy = False;
   while ((i < licz) && !nalezy)
   {
      if (!strcmp(sp[i],wyraz)) nalezy = True;
      i++;
   }
   return nalezy;
}

/* wypisuje zawartosc zbioru ubytki */
void Wypisz_ubytki(char* tab[])
{
   unsigned i;

   fputs("  defect ->  ",plik);
   for (i=0; i<defekt; i++)
      fprintf(plik,"%s  ",tab[i]);
   fputc('\n',plik);
}

/* dodaje wyraz do zbioru tab o licznosci licz */
unsigned Dodaj(char *wyraz,char* tab[],unsigned licz)
{
   strcpy(tab[licz],wyraz);
   return licz+1;
}

/* odejmuje wyraz ze zbioru tab o licznosci licz */
unsigned Odejmij(char *wyraz,char* tab[],unsigned licz)
{
   unsigned i = 0;

   while (strcmp(tab[i],wyraz)) i++;
   strcpy(tab[i],tab[licz-1]);
   return licz-1;
}

/* sprawdza, czy wierzcholek Stosu pokrywa sie z 
   poczatkiem jakiegokolwiek wyrazu ze spektrum */
enum Boolean Poczatek(int i,unsigned zaglebienie)
{
   char *wyraz = (char*) malloc(l * sizeof(char));
   int j=0;

   for (; i<zaglebienie; i++) 
      wyraz[j++]=litery[Stos[i]];
   wyraz[j] = '\0';
   for (i=0; i<count; i++)
      if (strstr(spektrum[i],wyraz) == spektrum[i]) 
	 break;
   free(wyraz);
   if (i == count) return False;
   return True;
}

void Konstrukcja()
{
   unsigned zaglebienie = 0,             /* biezacy poziom zaglebienia */
	    biezaca = 0;                 /* aktualnie rozpatrywana literka */
   char *wyraz = (char*) malloc((l+1) * sizeof(char));
				         /* ostatnia l-tka w lancuchu */
   int i,b;

   while (biezaca < 4)                   /* w tej petli przegladamy cale */
   {                                     /* drzewo literek */
      if (zaglebienie < pocz_len)
	 Stos[zaglebienie] = poczatek[zaglebienie]; /* kopiujemy do Stosu */
      else                               /* znany nam poczatek */
	 Stos[zaglebienie] = biezaca;    /* dodanie nowej literki do Stosu */
      ++zaglebienie;                     /* zwiekszenie poziomu zaglebienia */
      if (zaglebienie >= l)              /* mozna zaczac porownywac ostatnia */
      {                                  /* l-tke z zawartoscia zbiorow */
				         /* spektrum i ubytki */
	 strcpy(wyraz,Ostatnie_l(wyraz,zaglebienie));
	 if (Nalezy(wyraz,spektrum,count))
	    count = Odejmij(wyraz,spektrum,count);
	 else
	    defekt = Dodaj(wyraz,ubytki,defekt);
      }
      b = 0;
      if ((zaglebienie > k) && (zaglebienie < k+l))
      {                                  /* sprawdzanie "w przod" majace */
	                                 /* na celu ograniczenie drzewa */
	                                 /* budowanego obowiazkowo ( do */
	                                 /* glebokosci l+k ) */
	 if (zaglebienie < l) i=0;
	 else i=zaglebienie-l+1;
	 for (; i<zaglebienie; i++)   
            if (!Poczatek(i,zaglebienie))
	       b++;
      }
      if (zaglebienie < n) biezaca = 0;  /* przeszukujemy najpierw lewa */
				         /* galaz czyli zapelniamy Stos od */
				         /* najmniejszych wartosci (od A do T) */
      if ((zaglebienie == n) && (defekt == k))  /* gdy mamy juz lancuch o */
      {                                  /* dlugosci n a przy tym defekt jest */
				         /* rowny zamierzonemu */
	 Write();                        /* wypisujemy wlasciwe rozwiazanie */
	 if (wsz_ubytki) Wypisz_ubytki(ubytki); /* i ew. ubytki */
	 strcpy(wyraz,Ostatnie_l(wyraz,zaglebienie));
	 if (Nalezy(wyraz,ubytki,defekt))       /* cofamy sie o 1 */
	    defekt = Odejmij(wyraz,ubytki,defekt);
	 else
	    count = Dodaj(wyraz,spektrum,count);
	 biezaca = Stos[zaglebienie-1];
	 --zaglebienie;
	 ++biezaca;                      /* zaczynamy od nastepnej literki */
      }
      else if (b + defekt > k)           /* czyli nalezy sie odciac */
      {
	 if (zaglebienie >= l)
	 {
	    strcpy(wyraz,Ostatnie_l(wyraz,zaglebienie));
	    if (Nalezy(wyraz,ubytki,defekt))     /* cofamy sie o 1 */
	       defekt = Odejmij(wyraz,ubytki,defekt); 
            else
	       count = Dodaj(wyraz,spektrum,count);
         }
	 biezaca = Stos[zaglebienie-1];
	 if (sr_zaglebienie)             /* sredni poziom odciecia */
	 {
	    ++il_zagl;
	    poz_zagl += zaglebienie;
	 }
	 --zaglebienie;
	 ++biezaca;                      /* i zaczynamy od nastepnej w */
      }                                  /* kolejnosci literki */
      while (biezaca == 4)               /* gdy dochodzimy do ostatniej */
      {                                  /* galazki (czyli literka == T) */
				         /* nawracamy az do miejsca, gdzie */
				         /* literke biezaca bedzie mozna */
				         /* zwiekszyc o 1 */
	 if (zaglebienie >= l)           /* gdy mozna jeszcze usunac/dodac */
	 {                               /* ostatnia l-tke */
	    strcpy(wyraz,Ostatnie_l(wyraz,zaglebienie));
	    if (Nalezy(wyraz,ubytki,defekt))
	       defekt = Odejmij(wyraz,ubytki,defekt);
	    else
	       count = Dodaj(wyraz,spektrum,count);
	 }
	 if (zaglebienie) biezaca = Stos[zaglebienie-1];
	 else biezaca = 4;               /* gdy zaglebienie == 0 konczymy */
	 --zaglebienie;                  /* petle while poprzez podstawienie */
	 ++biezaca;                      /* za biezaca wartosci 5 */
	 if (zaglebienie < pocz_len) biezaca = 5;  /* konczymy konstrukcje */
      }
   }
   free(wyraz);
}

int main(int argc,char *argv[])
{
   Zainicjowanie();   	      
   plik = fopen("wyniki.dna","at");
   fprintf(plik,"n = %d, l = %d, k = %d\n",n,l,k);
   if (wszystkie_rozw) fprintf(plik,"Solutions :\n");
   times(&buf1);
   Konstrukcja();                  
   times(&buf2);                   
   if (liczba_rozw) fprintf(plik,
      "Total number of solutions : %.0f\n",ilosc_rozw);
   if (sr_zaglebienie) fprintf(plik,
      "Mean level of cut in search tree : %.2f\n",poz_zagl/il_zagl);
   fprintf(plik,"Computation time : %d sek\n\n",
      (buf2.tms_utime-buf1.tms_utime)/CLK_TCK);
   fclose(plik);
   Koniec();                       
   return 0;
}
